diff --git a/gnu/packages/build-tools.scm b/gnu/packages/build-tools.scm
index 33d91e6043..fb2deaa384 100644
--- a/gnu/packages/build-tools.scm
+++ b/gnu/packages/build-tools.scm
@@ -148,7 +148,7 @@ (define-public bear
      `(("c-ares" ,c-ares)
        ("fmt" ,fmt-8)
        ("grpc" ,grpc)
-       ("json-modern-cxx" ,json-modern-cxx)
+       ("nlohmann-json" ,json-modern-cxx)
        ("protobuf" ,protobuf)
        ("python" ,python-wrapper)
        ("re2" ,re2)
diff --git a/gnu/packages/cpp.scm b/gnu/packages/cpp.scm
index 023d1c0337..a041b4a3bb 100644
--- a/gnu/packages/cpp.scm
+++ b/gnu/packages/cpp.scm
@@ -595,9 +595,9 @@ (define-public json-dto
 data transfer object.")
     (license license:bsd-3)))
 
-(define-public json-modern-cxx
+(define-public nlohmann-json
   (package
-    (name "json-modern-cxx")
+    (name "nlohmann-json")
     (version "3.10.5")
     (home-page "https://github.com/nlohmann/json")
     (source
@@ -661,10 +661,13 @@ (define-public json-modern-cxx
     (inputs
      (list doctest fifo-map))
     (synopsis "JSON parser and printer library for C++")
-    (description "JSON for Modern C++ is a C++ JSON library that provides
+    (description "@code{nlohmann::json} is a C++ JSON library that provides
 intuitive syntax and trivial integration.")
     (license license:expat)))
 
+(define-public json-modern-cxx
+  (deprecated-package "json-modern-cxx" nlohmann-json))
+
 (define-public xtl
   (package
     (name "xtl")
@@ -680,7 +683,7 @@ (define-public xtl
                 "134pgvmf9cx5dxs0m0m3qhp3m3r1gl86ic3xax21zc4sdj8sdq46"))
               (file-name (git-file-name name version))))
     (native-inputs
-     (list doctest googletest json-modern-cxx))
+     (list doctest googletest nlohmann-json))
     (arguments
      '(#:configure-flags
        '("-DBUILD_TESTS=ON")
@@ -1859,7 +1862,7 @@ (define-public jsonnet
     (native-inputs
      (list googletest pkg-config))
     (inputs
-     (list json-modern-cxx))
+     (list nlohmann-json))
     (home-page "https://jsonnet.org/")
     (synopsis "Data templating language")
     (description "Jsonnet is a templating language extending JSON
diff --git a/gnu/packages/cybersecurity.scm b/gnu/packages/cybersecurity.scm
index 7bca251d06..cb03cbd5aa 100644
--- a/gnu/packages/cybersecurity.scm
+++ b/gnu/packages/cybersecurity.scm
@@ -89,7 +89,7 @@ (define-public blacksmith
     (native-inputs
      (list pkg-config))
     (inputs
-     (list argagg asmjit json-modern-cxx))
+     (list argagg asmjit nlohmann-json))
     (home-page "https://comsec.ethz.ch/research/dram/blacksmith")
     (synopsis "Rowhammer fuzzer with non-uniform and frequency-based patterns")
     (description
diff --git a/gnu/packages/databases.scm b/gnu/packages/databases.scm
index 4cd0d61da8..ae06fd3599 100644
--- a/gnu/packages/databases.scm
+++ b/gnu/packages/databases.scm
@@ -5023,7 +5023,7 @@ (define-public sqlitebrowser
     (build-system qt-build-system)
     (arguments
      (list #:configure-flags
-           ;; TODO: Unbundle json (json-modern-cxx).
+           ;; TODO: Unbundle json (nlohmann-json).
            #~(list (string-append "-DQSCINTILLA_INCLUDE_DIR="
                                   #$(this-package-input "qscintilla")
                                   "/include/Qsci")
diff --git a/gnu/packages/games.scm b/gnu/packages/games.scm
index 4fb9775e8d..f7140fdadc 100644
--- a/gnu/packages/games.scm
+++ b/gnu/packages/games.scm
@@ -4890,7 +4890,7 @@ (define-public openrct2
               ("freetype" ,freetype)
               ("icu4c" ,icu4c)
               ("jansson" ,jansson)
-              ("json-modern-cxx" ,json-modern-cxx)
+              ("nlohmann-json" ,json-modern-cxx)
               ("libpng" ,libpng)
               ("libzip" ,libzip)
               ("mesa" ,mesa)
diff --git a/gnu/packages/graphics.scm b/gnu/packages/graphics.scm
index 261fcf9547..0951770b12 100644
--- a/gnu/packages/graphics.scm
+++ b/gnu/packages/graphics.scm
@@ -2535,7 +2535,7 @@ (define-public f3d
     (native-inputs
      (list cxxopts
            help2man
-           json-modern-cxx))
+           nlohmann-json))
     (inputs
      (list alembic
            assimp
diff --git a/gnu/packages/hardware.scm b/gnu/packages/hardware.scm
index 5b85ad9b2e..c23299d1db 100644
--- a/gnu/packages/hardware.scm
+++ b/gnu/packages/hardware.scm
@@ -1059,7 +1059,7 @@ (define-public openrgb
                   (string-append #$(this-package-input "hueplusplus")
                                  "/include/hueplusplus"))
                  (("dependencies/json")
-                  (string-append #$(this-package-input "json-modern-cxx")
+                  (string-append #$(this-package-input "nlohmann-json")
                                  "/include/nlohmann")))))
            ;; Call qmake instead of configure to create a Makefile.
            (replace 'configure
@@ -1067,7 +1067,7 @@ (define-public openrgb
     (inputs
      (list hidapi
            hueplusplus
-           json-modern-cxx
+           nlohmann-json
            libusb
            mbedtls-apache
            qtbase-5))
diff --git a/gnu/packages/image-processing.scm b/gnu/packages/image-processing.scm
index cc0d5789b3..0aaac00870 100644
--- a/gnu/packages/image-processing.scm
+++ b/gnu/packages/image-processing.scm
@@ -1213,7 +1213,7 @@ (define-public paraview
            glew
            gmsh
            hdf5
-           ;;json-modern-cxx              ;For ParFlow; build fails
+           ;;nlohmann-json                ;For ParFlow; build fails
            jsoncpp
            libjpeg-turbo
            libogg
diff --git a/gnu/packages/irods.scm b/gnu/packages/irods.scm
index 5c9b66000c..a14ac87aa2 100644
--- a/gnu/packages/irods.scm
+++ b/gnu/packages/irods.scm
@@ -143,7 +143,7 @@ (define-public irods
        ("boost" ,boost-for-irods)
        ("cppzmq" ,cppzmq)
        ("fmt" ,fmt-6)
-       ("json" ,json-modern-cxx)
+       ("json" ,nlohmann-json)
        ("libarchive" ,libarchive)
        ("libcxxabi" ,libcxxabi-6) ; we need this for linking with -lc++abi
        ("linux-pam" ,linux-pam)
@@ -247,7 +247,7 @@ (define-public irods-client-icommands
        ("cppzmq" ,cppzmq)
        ("fmt" ,fmt-6)
        ("irods" ,irods)
-       ("json" ,json-modern-cxx)
+       ("json" ,nlohmann-json)
        ("libarchive" ,libarchive)
        ("libcxxabi" ,libcxxabi-6)     ; we need this for linking with -lc++abi
        ("mit-krb5" ,mit-krb5)
diff --git a/gnu/packages/jupyter.scm b/gnu/packages/jupyter.scm
index d0fcc82076..9337197cb2 100644
--- a/gnu/packages/jupyter.scm
+++ b/gnu/packages/jupyter.scm
@@ -196,7 +196,7 @@ (define-public xeus
            python-jupyter-client))
     (inputs
      (list xtl
-           json-modern-cxx
+           nlohmann-json
            cppzmq
            zeromq
            openssl
diff --git a/gnu/packages/messaging.scm b/gnu/packages/messaging.scm
index 2fa1c45f98..8441e41351 100644
--- a/gnu/packages/messaging.scm
+++ b/gnu/packages/messaging.scm
@@ -2325,7 +2325,7 @@ (define-public mtxclient
      (list boost
            coeurl
            curl
-           json-modern-cxx
+           nlohmann-json
            libevent
            libsodium
            olm
@@ -2408,7 +2408,7 @@ (define-public nheko
            gst-plugins-base
            gst-plugins-bad              ; sdp & webrtc for voip
            gst-plugins-good-qt          ; rtpmanager for voip
-           json-modern-cxx
+           nlohmann-json
            libevent
            libnice                      ; for voip
            olm
diff --git a/gnu/packages/text-editors.scm b/gnu/packages/text-editors.scm
index 8714940d1c..b23c5ba2be 100644
--- a/gnu/packages/text-editors.scm
+++ b/gnu/packages/text-editors.scm
@@ -393,7 +393,7 @@ (define-public jucipp
            clang-11               ;XXX: must be the same version as Mesas LLVM
            gtkmm-3
            gtksourceviewmm
-           json-modern-cxx
+           nlohmann-json
            libgit2
            universal-ctags))
     (synopsis "Lightweight C++ IDE")
diff --git a/gnu/packages/video.scm b/gnu/packages/video.scm
index 65fd92ea48..5fc23b777c 100644
--- a/gnu/packages/video.scm
+++ b/gnu/packages/video.scm
@@ -1027,7 +1027,7 @@ (define-public mkvtoolnix
        ("gettext" ,gettext-minimal)
        ("googletest" ,googletest)
        ("libxslt" ,libxslt)
-       ("json-modern-cxx" ,json-modern-cxx)
+       ("nlohmann-json" ,json-modern-cxx)
        ("perl" ,perl)
        ("pkg-config" ,pkg-config)
        ("po4a" ,po4a)
diff --git a/gnu/packages/xdisorg.scm b/gnu/packages/xdisorg.scm
index bee9711a74..3d66ddc862 100644
--- a/gnu/packages/xdisorg.scm
+++ b/gnu/packages/xdisorg.scm
@@ -3149,7 +3149,7 @@ (define-public nwg-launchers
                (base32
                 "0hq2qiqxvrw3g515ywcb676ljc8mdw3pyslgxr3vahizfljah1pv"))))
     (build-system meson-build-system)
-    (native-inputs (list json-modern-cxx pkg-config))
+    (native-inputs (list nlohmann-json pkg-config))
     (inputs (list gtk-layer-shell gtkmm-3 librsvg))
     (home-page "https://github.com/nwg-piotr/nwg-launchers")
     (synopsis "Application launchers for wlroots")