diff --git a/gnu/packages/kerberos.scm b/gnu/packages/kerberos.scm
index cc5f3f9ef2..3bfeefd558 100644
--- a/gnu/packages/kerberos.scm
+++ b/gnu/packages/kerberos.scm
@@ -174,108 +174,108 @@ (define-public shishi
 (define-public heimdal
   (let ((commit "a6cf94577c0d1e5bca5304342e4ddffb18255afe")
         (revision "1"))
-  (package
-    (name "heimdal")
-    (version (git-version "7.8.0" revision commit))
-    (source (origin
-              (method git-fetch)
-              (uri (git-reference
-                    (url "https://github.com/heimdal/heimdal")
-                    (commit commit)))
-              (file-name (git-file-name name version))
-              (sha256
-               (base32
-                "0df646hzi10s0w07kqzj10aniv6jsbmlpx6j3lqjvpsjpmm9lww9"))
-              (patches
-               (search-patches "heimdal-CVE-2022-45142.patch"))))
-    (build-system gnu-build-system)
-    (arguments
-     `(#:configure-flags
-       ,#~(list
-           ;; Avoid 7 MiB of .a files.
-           "--disable-static"
+    (package
+      (name "heimdal")
+      (version (git-version "7.8.0" revision commit))
+      (source (origin
+                (method git-fetch)
+                (uri (git-reference
+                      (url "https://github.com/heimdal/heimdal")
+                      (commit commit)))
+                (file-name (git-file-name name version))
+                (sha256
+                 (base32
+                  "0df646hzi10s0w07kqzj10aniv6jsbmlpx6j3lqjvpsjpmm9lww9"))
+                (patches
+                 (search-patches "heimdal-CVE-2022-45142.patch"))))
+      (build-system gnu-build-system)
+      (arguments
+       `(#:configure-flags
+         ,#~(list
+             ;; Avoid 7 MiB of .a files.
+             "--disable-static"
 
-           ;; Do not build libedit.
-           (string-append
-            "--with-readline-lib="
-            (assoc-ref %build-inputs "readline") "/lib")
-           (string-append
-            "--with-readline-include="
-            (assoc-ref %build-inputs "readline") "/include")
+             ;; Do not build libedit.
+             (string-append
+              "--with-readline-lib="
+              (assoc-ref %build-inputs "readline") "/lib")
+             (string-append
+              "--with-readline-include="
+              (assoc-ref %build-inputs "readline") "/include")
 
-           ;; Do not build sqlite.
-           (string-append
-            "--with-sqlite3="
-            (assoc-ref %build-inputs "sqlite"))
+             ;; Do not build sqlite.
+             (string-append
+              "--with-sqlite3="
+              (assoc-ref %build-inputs "sqlite"))
 
-           #$@(if (%current-target-system)
-                  ;; The configure script is too pessimistic.
-                  ;; Setting this also resolves a linking error.
-                  #~("ac_cv_func_getpwnam_r_posix=yes"
-                     ;; Allow 'slc' and 'asn1_compile' to be found.
-                     (string-append "--with-cross-tools="
-                                    #+(file-append this-package
-                                                   "/libexec/heimdal")))
-                  #~()))
-       #:phases (modify-phases %standard-phases
-                  ;; Skip the appl folder as obsolete per message from Brian May <brian@linuxpenguins.xyz>
-                  ;; <MDAEMON-F202305111940.AA401569md5001000003030@sequoia-grove.ad.secure-endpoints.com>
-                  (add-after 'unpack 'drop-obsolete-executables
-                    (lambda* (#:key inputs #:allow-other-keys)
-                      (substitute* '("Makefile.am")
-                        (("appl") ""))))
-                  (add-before 'configure 'pre-configure
-                    (lambda* (#:key inputs #:allow-other-keys)
-                      (substitute* "configure"
-                        ;; Reproducible build date, etc.
-                        (("User=.*$") "User=Guix\n")
-                        (("Host=.*$") "Host=GNU")
-                        (("Date=.*$") "Date=2022\n")
-                        ;; The e2fsprogs input is included for libcom_err,
-                        ;; let's use it even if cross-compiling.
-                        (("test \"\\$\\{krb_cv_com_err\\}\" = \"yes\"")
-                         ":")
-                        ;; Our 'compile_et' is not in --with-cross-tools,
-                        ;; which confuses heimdal.
-                        (("ac_cv_prog_COMPILE_ET=\\$\\{with_cross_tools\\}compile_et")
-                         "ac_cv_PROG_COMPILE_ET=compile_et"))
-                      (substitute* '("tools/Makefile.in")
-                        (("/bin/sh") (which "sh")))))
-                  (add-before 'check 'pre-check
-                    (lambda _
-                      ;; For 'getxxyyy-test'.
-                      (setenv "USER" (passwd:name (getpwuid (getuid))))
+             #$@(if (%current-target-system)
+                    ;; The configure script is too pessimistic.
+                    ;; Setting this also resolves a linking error.
+                    #~("ac_cv_func_getpwnam_r_posix=yes"
+                       ;; Allow 'slc' and 'asn1_compile' to be found.
+                       (string-append "--with-cross-tools="
+                                      #+(file-append this-package
+                                                     "/libexec/heimdal")))
+                    #~()))
+         #:phases (modify-phases %standard-phases
+                    ;; Skip the appl folder as obsolete per message from Brian May <brian@linuxpenguins.xyz>
+                    ;; <MDAEMON-F202305111940.AA401569md5001000003030@sequoia-grove.ad.secure-endpoints.com>
+                    (add-after 'unpack 'drop-obsolete-executables
+                      (lambda* (#:key inputs #:allow-other-keys)
+                        (substitute* '("Makefile.am")
+                          (("appl") ""))))
+                    (add-before 'configure 'pre-configure
+                      (lambda* (#:key inputs #:allow-other-keys)
+                        (substitute* "configure"
+                          ;; Reproducible build date, etc.
+                          (("User=.*$") "User=Guix\n")
+                          (("Host=.*$") "Host=GNU")
+                          (("Date=.*$") "Date=2022\n")
+                          ;; The e2fsprogs input is included for libcom_err,
+                          ;; let's use it even if cross-compiling.
+                          (("test \"\\$\\{krb_cv_com_err\\}\" = \"yes\"")
+                           ":")
+                          ;; Our 'compile_et' is not in --with-cross-tools,
+                          ;; which confuses heimdal.
+                          (("ac_cv_prog_COMPILE_ET=\\$\\{with_cross_tools\\}compile_et")
+                           "ac_cv_PROG_COMPILE_ET=compile_et"))
+                        (substitute* '("tools/Makefile.in")
+                          (("/bin/sh") (which "sh")))))
+                    (add-before 'check 'pre-check
+                      (lambda _
+                        ;; For 'getxxyyy-test'.
+                        (setenv "USER" (passwd:name (getpwuid (getuid))))
 
-                      ;; Skip 'db' and 'kdc' tests for now.
-                      ;; FIXME: figure out why 'kdc' tests fail.
-                      (with-output-to-file "tests/db/have-db.in"
-                        (lambda ()
-                          (format #t "#!~a~%exit 1~%" (which "sh")))))))
-       ;; Tests fail when run in parallel.
-       #:parallel-tests? #f))
-    (native-inputs (list autoconf
-                         automake
-                         bison
-                         e2fsprogs      ;for 'compile_et'
-                         flex
-                         libtool
-                         texinfo
-                         unzip          ;for tests
-                         pkg-config
-                         perl
-                         perl-json
-                         python))
-    (inputs (list readline
-                  bash-minimal
-                  bdb
-                  e2fsprogs             ;for libcom_err
-                  libcap-ng
-                  openldap
-                  sqlite))
-    (home-page "http://www.h5l.org/")
-    (synopsis "Kerberos 5 network authentication")
-    (description
-     "Heimdal is an implementation of Kerberos 5 network authentication
+                        ;; Skip 'db' and 'kdc' tests for now.
+                        ;; FIXME: figure out why 'kdc' tests fail.
+                        (with-output-to-file "tests/db/have-db.in"
+                          (lambda ()
+                            (format #t "#!~a~%exit 1~%" (which "sh")))))))
+         ;; Tests fail when run in parallel.
+         #:parallel-tests? #f))
+      (native-inputs (list autoconf
+                           automake
+                           bison
+                           e2fsprogs      ;for 'compile_et'
+                           flex
+                           libtool
+                           texinfo
+                           unzip          ;for tests
+                           pkg-config
+                           perl
+                           perl-json
+                           python))
+      (inputs (list readline
+                    bash-minimal
+                    bdb
+                    e2fsprogs             ;for libcom_err
+                    libcap-ng
+                    openldap
+                    sqlite))
+      (home-page "http://www.h5l.org/")
+      (synopsis "Kerberos 5 network authentication")
+      (description
+       "Heimdal is an implementation of Kerberos 5 network authentication
 service.")
-    (license license:bsd-3))))
+      (license license:bsd-3))))
 